<?php

class DirectadminConfigurationController extends DirectadminMasterControllerDriver
{

    public function MainHTMLAction($input,$data = array())
    {
        //errors:
        $fieldErorrs = isset($data['fieldErrors'])?$data['fieldErrors']:array();

        //predefined configuration for autoconfig script:
        $predefinedConfig = new DirectadminApiConfigurationDriver('PredefinedConfiguration.ini');

        $data['isForm'] = true;

        //define new form with action that redirects to itself. sys is the lang prefix
        $form = new FormCreator('sys',$this,array(
            'url'    => $this->getCurrentAction()
        ));
        $data['url'] = $this->getCurrentAction();

        $customParams['doubleButtons'][] = array('name' => 'submitLoadConfFile', 'value' => 'loadConfFile');
        $customParams['doubleButtons'][] = array('name' => 'submitSaveConfFile', 'value' => 'saveConfFile');
        $form->addField('Submit', array(
            'name'                   => 'action',
            'value'                  => 'double',
            'frendlyName'            => 'double',
            'skipLabel'              => true,
            'customParams'           => $customParams
        ));

        /*
        * API SECTION - CERTUM
        */
        //add fields - parameters: type (see Classes/Form/*.php), array([see: FormAbstractField.php]'name'=>id(without prefix,'value'=>actual value,'error'=>what is displayed on errors,'friendlyName'=>friendly name,'rows'=>for textarea,'cols'=>for textarea,'enableDescription'=>description under field))
        $form->addField('Legend',array(//caption
            'name'  => 'admin_api_section'
        ));

        $form->addField('Hidden', array(
            'name' => 'testConnectionId',
            'value' => '',
        ));

        $configuration = new CertumSSLConfiguration();

        if (count($configuration->getAPIAccountsParams()) <= 0) {

            $relid = 1;
            $form->addField('Text',
                array(
                'name' => 'api_login_'.$relid,
                'value' => isset($input['sys_api_login_'.$relid]) ? $input['sys_api_login_'.$relid] : $predefinedConfig->api_login,
                'error' => (!empty($fieldErorrs['sys_api_login_'.$relid]))
            ));

            $form->addField('Text',
                array(
                'name' => 'api_password_'.$relid,
                'value' => isset($input['sys_api_password_'.$relid]) ? $input['sys_api_password_'.$relid] : $predefinedConfig->api_password,
                'error' => (!empty($fieldErorrs['sys_api_password_'.$relid]))
            ));

            $form->addField('Text',
                array(
                'name' => 'api_wsdl_url_'.$relid,
                'value' => isset($input['sys_api_wsdl_url_']) ? $input['sys_api_wsdl_url_'.$relid] : $predefinedConfig->api_wsdl_url,
                'error' => (!empty($fieldErorrs['sys_api_wsdl_url_'.$relid]))
            ));

            $SSLProducts = new SSLProducts();

            $form->addField('MultiSelect', array(
                'name' => 'api_wsdl_products_'.$relid,
                'options' => $SSLProducts->names,
            ));

            $form->addField('Text',
                array(
                'name' => 'api_wsdl_lang_'.$relid,
                'value' => isset($input['sys_api_wsdl_lang_'.$relid]) ? $input['sys_api_wsdl_lang_'.$relid] : $predefinedConfig->api_wsdl_lang,
                'error' => (!empty($fieldErorrs['sys_api_wsdl_lang_'.$relid]))
            ));

            $customParams['doubleButtons'][0] = array('name' => 'testConnect', 'value' => 'testConnect');
            $customParams['doubleButtons'][1] = array('name' => 'addNewAccount', 'type' => 'button', 'value' => 'addNewAccount', 'data-lastrelid' => $relid);
            $form->addField('Submit',
                array(
                'name' => 'action',
                'value' => 'double',
                'frendlyName' => 'double',
                'skipLabel' => false,
                'customParams' => $customParams
            ));
        } else {
            $i = 0;
            foreach ($configuration->getAPIAccountsParams() as $relid => $accountParams) {
                $i++;
                $form->addField('Text',
                    array(
                    'name' => 'api_login_'.$relid,
                    'value' => isset($input['sys_api_login_'.$relid]) ? $input['sys_api_login_'.$relid] : (isset($accountParams['api_login']) ? $accountParams['api_login'] : $predefinedConfig->api_login),
                    'error' => (!empty($fieldErorrs['sys_api_login_'.$relid]))
                ));

                $form->addField('Text',
                    array(
                    'name' => 'api_password_'.$relid,
                    'value' => isset($input['sys_api_password_'.$relid]) ? $input['sys_api_password_'.$relid] : (isset($accountParams['api_password']) ? $accountParams['api_password']
                                : $predefinedConfig['api_password']),
                    'error' => (!empty($fieldErorrs['sys_api_password_'.$relid]))
                ));

                $form->addField('Text',
                    array(
                    'name' => 'api_wsdl_url_'.$relid,
                    'value' => isset($input['sys_api_wsdl_url_']) ? $input['sys_api_wsdl_url_'.$relid] : (isset($accountParams['api_wsdl_url']) ? $accountParams['api_wsdl_url'] : $predefinedConfig->api_wsdl_url),
                    'error' => (!empty($fieldErorrs['sys_api_wsdl_url_'.$relid]))
                ));

                $SSLProducts = new SSLProducts();

                $form->addField('MultiSelect',
                    array(
                    'name' => 'api_wsdl_products_'.$relid,
                    'options' => $SSLProducts->names,
                    'customParams' => array('selected' => $configuration->getProductsByRelId($relid))
                ));

                $form->addField('Text',
                    array(
                    'name' => 'api_wsdl_lang_'.$relid,
                    'value' => isset($input['sys_api_wsdl_lang_'.$relid]) ? $input['sys_api_wsdl_lang_'.$relid] : (isset($accountParams['api_wsdl_lang']) ? $accountParams['api_wsdl_lang']
                                : $predefinedConfig['api_wsdl_lang']),
                    'error' => (!empty($fieldErorrs['sys_api_wsdl_lang_'.$relid]))
                ));

                if (count($configuration->getAPIAccountsParams()) != $i) {
                    $customParams['doubleButtons'][0] = array('name' => 'testConnect', 'value' => 'testConnect', 'isTestConnection' => true, 'related' => $i);
                    unset($customParams['doubleButtons'][1]);
                    $form->addField('Submit',
                        array(
                        'name' => 'action',
                        'value' => 'double',
                        'frendlyName' => 'double',
                        'skipLabel' => false,
                        'customParams' => $customParams
                    ));
                }

                if (count($configuration->getAPIAccountsParams()) == $i) {
                    unset($customParams['doubleButtons'][0]);
                    unset($customParams['doubleButtons'][1]);
                    $customParams['doubleButtons'][0] = array('name' => 'testConnect', 'value' => 'testConnect', 'isTestConnection' => true, 'related' => $i);
                    $customParams['doubleButtons'][1] = array('name' => 'addNewAccount', 'type' => 'button', 'value' => 'addNewAccount', 'data-lastrelid' => $i);
                    $form->addField('Submit',
                        array(
                        'name' => 'action',
                        'value' => 'double',
                        'frendlyName' => 'double',
                        'skipLabel' => false,
                        'customParams' => $customParams
                    ));
                }
            }
        }

        /*
        * ADMIN NOTIFICATIONS
        */
        $form->addField('Legend',array(
            'name'  => 'admin_notification_section'
        ));

        $form->addField('Text', array(
            'name'  => 'email',
            'value' => isset($input['sys_email'])?$input['sys_email']: (isset($this->config->email)?$this->config->email:$predefinedConfig->get('email')),
            'error' => (!empty($fieldErorrs['sys_email']))
        ));

        $form->addField('Text', array(
            'name'  => 'sender',
            'value' => isset($input['sys_sender'])?$input['sys_sender']:(isset($this->config->sender)?$this->config->sender:$predefinedConfig->get('sender')),
            'error' => (!empty($fieldErorrs['sys_sender']))
        ));


        /*
        * USER NOTIFICATIONS
        */
        $form->addField('Legend',array(
            'name'  => 'user_notification_section'
        ));

        $form->addField('Text', array(
            'name'  => 'success_email_subject',
            'value' => isset($input['sys_success_email_subject'])?$input['sys_success_email_subject']:(isset($this->config->success_email_subject)?$this->config->success_email_subject:$predefinedConfig->get('success_email_subject'))
        ));

        $form->addField('TextArea', array(
            'rows'                  => 10,
            'cols'                  => 55,
            'name'                  => 'success_email_message',
            'value'                 => isset($input['sys_success_email_message'])?$input['sys_success_email_message']:(isset($this->config->success_email_message)?$this->config->success_email_message:$predefinedConfig->get('success_email_message')),
            'enableDescription'     => true
        ));

        //Billing Configuration
        $form->addField('Legend',array(
            'name'  => 'billing_config_subject'
        ));

        $form->addField('Text', array(
            'name'              => 'billing_url',
            'value'             => isset($input['sys_billing_url'])?$input['sys_billing_url']:(isset($this->config->billing_url)?$this->config->billing_url:$predefinedConfig->get('billing_url')),
            'error'             => (!empty($fieldErorrs['sys_billing_url'])),
            'enableDescription' => true
        ));

        //API Logs Configuration
        $form->addField('Legend',array(
            'name'  => 'logs_limit_subject'
        ));

        $form->addField('Text', array(
            'name'              => 'logs_limit',
            'value'             => isset($input['sys_logs_limit'])?$input['sys_logs_limit']:(isset($this->config->logs_limit)?$this->config->logs_limit:$predefinedConfig->get('logs_limit')),
            'error'             => (!empty($fieldErorrs['sys_logs_limit'])),
            'enableDescription' => true
        ));

        $form->addField('Submit', array(
            'name'          => 'action',
            'value'         => 'save',
            'frendlyName'   => 'submitSave'
        ));


        $data['formAPI'] = $form->getHTML();

        $data['moduleName'] = DACERTUM_MODULENAME;

        return array(
            'template'   => 'Configuration',
            'vars'       => $data
        );

    }


    public function saveHTMLAction($input,$data = array())
    {
        $configuration = new CertumSSLConfiguration();

        foreach ($input as $inpuName => $inpuVal) {

            if (strpos($inpuName, "sys_api_") !== false) {
                $last  = strrpos($inpuName, "_");
                $relid = substr($inpuName, (int) $last + 1 - strlen($inpuName));
                $name  = substr($inpuName, 4, $last - 4);

                if (strpos($inpuName, "api_wsdl_products") !== false) {
                    $inpuVal = json_encode($inpuVal);
                }

                $configuration->setAPIAccountsParams($name, $inpuVal, $relid);

                if(!array_key_exists("sys_api_wsdl_products_".$relid,$input)){
                    $configuration->setAPIAccountsParams("api_wsdl_products","" , $relid);
                }
            }
        }

        $this->config->email                  = $input['sys_email'];
        $this->config->sender                 = $input['sys_sender'];

        $this->config->success_email_subject  = $input['sys_success_email_subject'];
        $this->config->success_email_message  = $input['sys_success_email_message'];

        $this->config->billing_url            = $input['sys_billing_url'];

        $this->config->logs_limit             = $input['sys_logs_limit'];

        $data['success'] = MGLang::T('saveSuccess');

        return $this->MainHTMLAction($input,$data);
    }


    public function testConnectHTMLAction($input,$data = array())
    {
        if (isset($input['sys_testConnectionId'])) {
            $connectionParams = array(
                'api_login' => $input['sys_api_login_'.$input['sys_testConnectionId']],
                'api_password' => $input['sys_api_password_'.$input['sys_testConnectionId']],
                'api_url' => $input['sys_api_wsdl_url_'.$input['sys_testConnectionId']],
                'api_wsdl_lang' => $input['sys_api_wsdl_lang_'.$input['sys_testConnectionId']],
            );

            CertumSSLDriver::remoteAPI()->setConnectionParams($connectionParams);
            $op = CertumSSLDriver::remoteAPI()->operationGetProductList();
            $response = $op->call();
            if (!$response || (!is_object($response) && isset($response['errors']))) {
                $data['error'] = MGLang::T('connectError');
            } else {
                $data['success'] = MGLang::T('connectSuccess');
            }

            $configuration = new CertumSSLConfiguration();
            $configuration->setAPIAccountsParams('api_login', $input['sys_api_login_'.$input['sys_testConnectionId']], $input['sys_testConnectionId']);
            $configuration->setAPIAccountsParams('api_password', $input['sys_api_password_'.$input['sys_testConnectionId']], $input['sys_testConnectionId']);
            $configuration->setAPIAccountsParams('api_wsdl_url', $input['sys_api_wsdl_url_'.$input['sys_testConnectionId']], $input['sys_testConnectionId']);
            $configuration->setAPIAccountsParams('api_wsdl_lang', $input['sys_api_wsdl_lang_'.$input['sys_testConnectionId']], $input['sys_testConnectionId']);
            $configuration->setAPIAccountsParams('api_wsdl_products', json_encode($input['sys_api_wsdl_products_'.$input['sys_testConnectionId']]), $input['sys_testConnectionId']);
        }
        return $this->MainHTMLAction($input, $data);
    }

    public function loadConfFileHTMLAction()
    {
        $predefinedConfig = parse_ini_file('/usr/local/directadmin/plugins/certum_ssl/PredefinedConfiguration.ini');
        $configuration    = new CertumSSLConfiguration();
        foreach ($predefinedConfig as $configName => $configValues) {
            if (strpos($configName, "api_") !== false && is_array($configValues)) {

                foreach ($configValues as $relid => $value) {
                    if (strpos($configName, "api_wsdl_products") !== false) {
                        $productsArray = explode(",", $value);
                        $value         = json_encode($productsArray);
                    }

                    $configuration->setAPIAccountsParams($configName, $value, $relid);
                }
            } else {
                $configuration->setAPIAccountsParams($configName, $configValues, 0);
            }
        }

        $data['success'] = MGLang::T('loadConfigMessage');

        return $this->MainHTMLAction(null, $data);
    }

    public function saveConfFileHTMLAction($input,$data = array())
    {
        $res = array();
        foreach ($input as $inpuName => $inpuVal) {

            if (strpos($inpuName, "sys_api_") !== false) {
                $last  = strrpos($inpuName, "_");
                $relid = substr($inpuName, (int) $last + 1 - strlen($inpuName));

                $name = substr($inpuName, 4, $last - 4);

                if (strpos($inpuName, "api_wsdl_products") !== false) {
                    $inpuVal = implode(",", $inpuVal);
                }

                $res[] = $name."[".$relid."] = ".$inpuVal;
            } else {
                if (strpos($inpuName, 'sys_') !== false && strpos($inpuName, 'sys_testConnectionId') === false) {
                    $inpuName = str_replace("sys_", "", $inpuName);
                    if (is_array($inpuVal)) {
                        $res[] = "[$inpuName]";
                        foreach ($inpuVal as $skey => $sval)
                            $res[] = "$skey = ".(is_numeric($sval) ? $sval : '"'.$sval.'"');
                    } else {
                        $res[] = "$inpuName = ".(is_numeric($inpuVal) ? $inpuVal : '"'.$inpuVal.'"');
                    }
                }
            }
        }
        $dataToSave = implode("\r\n", $res);

        $configFile = fopen('/usr/local/directadmin/plugins/certum_ssl/PredefinedConfiguration.ini', 'w');
        fwrite($configFile, $dataToSave);
        fclose($configFile);

        $data['success'] = MGLang::T('saveConfigMessage')." /usr/local/directadmin/plugins/certum_ssl/PredefinedConfiguration.ini";

        return $this->MainHTMLAction(null, $data);

//        @ob_start();
//        header('Content-Description: File Transfer');
//        header('Content-Type: application/octet-stream');
//        header('Content-Disposition: attachment; filename="'.basename($path).'"');
//        header('Expires: 0');
//        header('Cache-Control: must-revalidate');
//        header('Pragma: public');
//        header('Content-Length: ' . filesize($path));
//        echo readfile($path);

    }
}