<?php
//NTODO: unused
class CPanelMainController extends AbstractControler
{    
    public $clientUsername;

    public function __construct($parent, $options = array()) 
    {
        parent::__construct($parent, $options);
    }

    public function MainHTMLAction($input,$vars = array()) 
    {  
        $account            = new CertumSSLAccount($this->clientUsername);
        $account->nameID    = $this->clientUsername;
        
        $vars['certs'] = $account->getCerts();
        
        $form = new FormCreator('cert', $this);
        
        $form->addField('Text', array(
            'name'  => 'order_token'
            ,'require'  => true
        ));

        $domainList = array();
   
        foreach ($account->getDomains() as $domain){
            $domainList[$domain->domain] = $domain->domain;
        }
         
        $form->addField('Select', array(
            'name'      => 'domain'
            ,'options'  => $domainList
        ));
         
        $form->addField('Submit', array(
            'name'      => 'action'
            ,'value'    => 'addCertificate'
        ));

        $vars['addForm'] = $form->getHTML();

        $cancelForm = new FormCreator('certCancel', $this);
        $form->addField('Hidden', array(
            'name'  => 'order_token'
            ,'require'  => true
        ));

        return array(
            'template'   => 'Main'
            ,'vars'      => $vars
        );
    }
    
    
    function certCancelHTMLAction()
    {
        $certificate                = new CertumSSLCertificate();
        $certificate->orderToken    = $_POST["voucherCode"];
        $certificate->userId        = $this->clientUsername;
        $certificate->domain        = $_POST["domainName"];
        $certificate->domainId      = $_POST["domainName"];
        $certificate->cancelCertOrder();
        
        if(!empty($certificate->errors) && array_key_exists('GetOrderInfByVoucherCode',$certificate->errors)){
            $errorsArray = $certificate->errors;
            echo "<<JSON RESPONSE START>>";
            echo json_encode(array('status' => 'error', 'msg' => $errorsArray['GetOrderInfByVoucherCode']['GetOrderInfErrorMessage']));
            echo "<<JSON RESPONSE END>>";
            die(); 
        }
        
        if(!empty($certificate->errors) && array_key_exists('Cancel',$certificate->errors)){
            $errorsArray = $certificate->errors;
            echo "<<JSON RESPONSE START>>";
            echo json_encode(array('status' => 'error', 'msg' => $errorsArray['Cancel']['CancelErrorMessage']));
            echo "<<JSON RESPONSE END>>";
            die();    
        }
        
        echo "<<JSON RESPONSE START>>";
        echo json_encode(array('status' => 'success', 'msg' => 'Certificate has been cancelled'));
        echo "<<JSON RESPONSE END>>";
        die();   
    }
    
    function certRevokeHTMLAction()
    {
        $certificate                = new CertumSSLCertificate();
        $certificate->orderToken    = $_POST["voucherCode"];
        $certificate->userId        = $this->clientUsername;
        $certificate->domain        = $_POST["domainName"];
        $certificate->domainId      = $_POST["domainName"];
        
        $certificate->revokeCertOrder();
        
        if(!empty($certificate->errors) && array_key_exists('GetOrderInfByVoucherCode',$certificate->errors)){
            $errorsArray = $certificate->errors;
            echo "<<JSON RESPONSE START>>";
            echo json_encode(array('status' => 'error', 'msg' => $errorsArray['GetOrderInfByVoucherCode']['GetOrderInfErrorMessage']));
            echo "<<JSON RESPONSE END>>";
            die(); 
        }
        
        if(!empty($certificate->errors) && array_key_exists('Revoke',$certificate->errors)){
            $errorsArray = $certificate->errors;
            echo "<<JSON RESPONSE START>>";
            echo json_encode(array('status' => 'error', 'msg' => $errorsArray['Revoke']['RevokeErrorMessage']));
            echo "<<JSON RESPONSE END>>";
            die();    
        }
        
        echo "<<JSON RESPONSE START>>";
        echo json_encode(array('status' => 'success', 'msg' => 'Certificate has been revoked.'));
        echo "<<JSON RESPONSE END>>";
        die();   
    }
    
    
    function certReissueHTMLAction($input,$vars = array())
    {

        $certificate             = new CertumSSLCertificate();
        $certificate->account    = $this->clientUsername;
        $certificate->userId     = $this->clientUsername;
        if(isset($_POST["cert_domain"])){
            $certificate->domain     = $_POST["cert_domain"];
            $certificate->domainId   = $_POST["cert_domain"];
            $certificate->orderToken = $_POST["cert_order_token"];
        }elseif(isset($input['reissue_domain'])){
            $certificate->domain     = $input['reissue_domain'];
            $certificate->domainId   = $input['reissue_domain'];
            $certificate->orderToken = $input['reissue_order_token'];
        }
       

        $aprroverList            = true;
        
        $fieldErorrs = isset($vars['fieldErrors'])?$vars['fieldErrors']:array();
        
        $voucherdvMethods = $certificate->getVoucherDVMethod();

        if($voucherdvMethods){
            foreach($voucherdvMethods as $voucherdvMethod){
                if($voucherdvMethod == 'DV' || $voucherdvMethod == 'OV' || $voucherdvMethod == 'EV'){
                    $aprroverList = false;
                }
            }
        }else{
            $aprroverList = false;
        }
         
        $form = new FormCreator('reissue', $this);
        
        $form->addField('Text', array(
            'name'      => 'order_token'
            ,'value'    => $certificate->orderToken
            ,'readonly' => true
        ));
                         
        $form->addField('Text', array(
            'name'      => 'domain'
            ,'value'    => isset($input['reissue_domain'])?$input['reissue_domain']:$_POST["cert_domain"]
            ,'readonly' => true
        ));
 
        $options = array();

        if($aprroverList){
            foreach($certificate->getApproverList() as $email){
                $options[$email] = $email;
            }
            $form->addField('Select', array(
                'name'      => 'approver_email'
                ,'options'  => $options
            ));
        }
       
        $form->addField('Legend', array(
            'name'      => 'org'
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_name'
            ,'value'    => isset($input['reissue_org_name'])?$input['reissue_org_name']:null
            ,'error'    => (!empty($fieldErorrs['reissue_org_name']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_postalcode'
            ,'value'    => isset($input['reissue_org_postalcode'])?$input['reissue_org_postalcode']:null,
            'error'     => (!empty($fieldErorrs['reissue_org_postalcode']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_address_city'
            ,'value'    => isset($input['reissue_org_address_city'])?$input['reissue_org_address_city']:null
            ,'error'    => (!empty($fieldErorrs['reissue_org_address_city']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_address_region'
            ,'value'    => isset($input['reissue_org_address_region'])?$input['reissue_org_address_region']:null
            ,'error'    => (!empty($fieldErorrs['reissue_org_address_region']))
            ,'require'  => true
        ));
        
        $form->addField('Select', array(
            'name'      => 'org_address_country'
            ,'value'    => isset($input['reissue_org_address_country'])?$input['reissue_org_address_country']:null
            ,'options'  => CertumSSLCertificate::getCountries()
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_address_email'
            ,'value'    => isset($input['reissue_org_address_email'])?$input['reissue_org_address_email']:null
            ,'error'    => (!empty($fieldErorrs['reissue_org_address_email']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_address_line1'
            ,'value'    => isset($input['reissue_org_address_line1'])?$input['reissue_org_address_line1']:null
            ,'error'    => (!empty($fieldErorrs['reissue_org_address_line1']))
            ,'require'  => true
        ));
                
        $form->addField('Text', array(
            'name'      => 'org_address_line2'
            ,'value'    => isset($input['reissue_org_address_line2'])?$input['reissue_org_address_line2']:null
            ,'error'    => (!empty($fieldErorrs['reissue_org_address_line2']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_address_phone'
            ,'value'    => isset($input['reissue_org_address_phone'])?$input['reissue_org_address_phone']:null
            ,'error'    => (!empty($fieldErorrs['reissue_org_address_phone']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_address_fax'
            ,'value'    => isset($input['reissue_org_address_fax'])?$input['reissue_org_address_fax']:null
            ,'error'    => (!empty($fieldErorrs['reissue_org_address_fax']))
            ,'require'  => true
        ));
        
        $form->addField('Submit', array(
            'name'      => 'action'
            ,'value'    => 'submitCertReissue'
            ,'cancel'   => true
        ));
        
        $vars['addForm'] = $form->getHTML();
        
        return array(
            'template'   => 'addReissue'
            ,'vars'      => $vars
        );
    }
    
    function addCertificateHTMLAction($input,$vars = array())
    {
        $certificate             = new CertumSSLCertificate();
        $certificate->account    = $this->clientUsername;
        $certificate->domain     = $input['cert_domain'];
        $certificate->domainId   = $input['cert_domain'];
        $certificate->orderToken = $input['cert_order_token'];
        $aprroverList            = true;

        $fieldErorrs = isset($vars['fieldErrors'])?$vars['fieldErrors']:array();

        //Check Voucher if exist and if is redeemed
        
        switch($certificate->checkVoucher()){
            case 'available':
            break;
            case 'redeemed' :
                $vars['error'] = MGLang::T('redeemedError');
                return $this->MainHTMLAction($input, $vars);
            break;
            case 'notexist' :
                $vars['error'] = MGLang::T('notexistError');
                return $this->MainHTMLAction($input, $vars);
            break;
            case 'emptytoken' :
                $vars['error'] = MGLang::T('emptytokenError');
                return $this->MainHTMLAction($input, $vars);
            break;
            case 'orderexist' :
                $vars['error'] = MGLang::T('orderexistError');
                return $this->MainHTMLAction($input, $vars);
            break;
            case 'errorauth' :
                $vars['error'] = MGLang::T('errorAuth');
                return $this->MainHTMLAction($input, $vars);
            break;
            default:
                $vars['error'] = MGLang::T('nonevoucherError');
                return $this->MainHTMLAction($input, $vars);
        }   
        
        $voucherdvMethods = $certificate->getVoucherDVMethod();
        foreach($voucherdvMethods as $voucherdvMethod){
            if($voucherdvMethod == 'DV' || $voucherdvMethod == 'OV' || $voucherdvMethod == 'EV'){
                $aprroverList = false;
            }
        }

        $form = new FormCreator('cert',  $this, array('cancel' => true));

        $form->addField('Text', array(
            'name'      => 'order_token'
            ,'value'    => $certificate->orderToken
            ,'readonly' => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'domain'
            ,'value'    => $input['cert_domain']
            ,'readonly' => true
        ));

        $options = array();
           
        if($aprroverList){
            foreach($certificate->getApproverList() as $email){

                $options[$email] = $email;
            }
            $form->addField('Select', array(
                'name'      => 'approver_email'
                ,'options'  => $options
            ));
        }
        
        $form->addField('Legend', array(
            'name'      => 'tech_contact'
        ));
        
        $form->addField('Text', array(
            'name'      => 'tech_contact_title'
            ,'value'    => isset($input['cert_tech_contact_title'])?$input['cert_tech_contact_title']:null
            ,'error'    => (!empty($fieldErorrs['cert_tech_contact_title']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'tech_contact_first_name'
            ,'value'    => isset($input['cert_tech_contact_first_name'])?$input['cert_tech_contact_first_name']:null
            ,'error'    => (!empty($fieldErorrs['cert_tech_contact_first_name']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'tech_contact_last_name'
            ,'value'    => isset($input['cert_tech_contact_last_name'])?$input['cert_tech_contact_last_name']:null
            ,'error'    => (!empty($fieldErorrs['cert_tech_contact_last_name']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'tech_contact_phone'
            ,'value'    => isset($input['cert_tech_contact_phone'])?$input['cert_tech_contact_phone']:null
            ,'error'    => (!empty($fieldErorrs['cert_tech_contact_phone']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'tech_contact_email'
            ,'value'    => isset($input['cert_tech_contact_email'])?$input['cert_tech_contact_email']:null
            ,'error'    => (!empty($fieldErorrs['cert_tech_contact_email']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'tech_contact_fax'
            ,'value'    => isset($input['cert_tech_contact_fax'])?$input['cert_tech_contact_fax']:null
            ,'error'    => (!empty($fieldErorrs['cert_tech_contact_fax']))
            ,'require'  => true
        ));
        
        $form->addField('Legend', array(
            'name'      => 'admin_contact'
        ));
        
        $form->addField('Text', array(
            'name'      => 'admin_contact_title'
            ,'value'    => isset($input['cert_admin_contact_title'])?$input['cert_admin_contact_title']:null
            ,'error'    => (!empty($fieldErorrs['cert_admin_contact_title']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'admin_contact_first_name'
            ,'value'    => isset($input['cert_admin_contact_first_name'])?$input['cert_admin_contact_first_name']:null
            ,'error'    => (!empty($fieldErorrs['cert_admin_contact_first_name']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'admin_contact_last_name'
            ,'value'    => isset($input['cert_admin_contact_last_name'])?$input['cert_admin_contact_last_name']:null
            ,'error'    => (!empty($fieldErorrs['cert_admin_contact_last_name']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'admin_contact_phone'
            ,'value'    => isset($input['cert_admin_contact_phone'])?$input['cert_admin_contact_phone']:null
            ,'error'    => (!empty($fieldErorrs['cert_admin_contact_phone']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'admin_contact_email'
            ,'value'    => isset($input['cert_admin_contact_email'])?$input['cert_admin_contact_email']:null
            ,'error'    => (!empty($fieldErorrs['cert_admin_contact_email']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'admin_contact_fax'
            ,'value'    => isset($input['cert_admin_contact_fax'])?$input['cert_admin_contact_fax']:null
            ,'error'    => (!empty($fieldErorrs['cert_admin_contact_fax']))
            ,'require'  => true
        ));
        
        $form->addField('Legend', array(
            'name'      => 'org'
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_name'
            ,'value'    => isset($input['cert_org_name'])?$input['cert_org_name']:null
            ,'error'    => (!empty($fieldErorrs['cert_org_name']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_postalcode'
            ,'value'    => isset($input['cert_org_postalcode'])?$input['cert_org_postalcode']:null,
            'error'     => (!empty($fieldErorrs['cert_org_postalcode']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_address_city'
            ,'value'    => isset($input['cert_org_address_city'])?$input['cert_org_address_city']:null
            ,'error'    => (!empty($fieldErorrs['cert_org_address_city']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_address_region'
            ,'value'    => isset($input['cert_org_address_region'])?$input['cert_org_address_region']:null
            ,'error'    => (!empty($fieldErorrs['cert_org_address_region']))
            ,'require'  => true
        ));
        
        $form->addField('Select', array(
            'name'      => 'org_address_country'
            ,'value'    => isset($input['cert_org_address_country'])?$input['cert_org_address_country']:null
            ,'options'  => CertumSSLCertificate::getCountries()
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_address_email'
            ,'value'    => isset($input['cert_org_address_email'])?$input['cert_org_address_email']:null
            ,'error'    => (!empty($fieldErorrs['cert_org_address_email']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_address_line1'
            ,'value'    => isset($input['cert_org_address_line1'])?$input['cert_org_address_line1']:null
            ,'error'    => (!empty($fieldErorrs['cert_org_address_line1']))
            ,'require'  => true
        ));
                
        $form->addField('Text', array(
            'name'      => 'org_address_line2'
            ,'value'    => isset($input['cert_org_address_line2'])?$input['cert_org_address_line2']:null
            ,'error'    => (!empty($fieldErorrs['cert_org_address_line2']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_address_phone'
            ,'value'    => isset($input['cert_org_address_phone'])?$input['cert_org_address_phone']:null
            ,'error'    => (!empty($fieldErorrs['cert_org_address_phone']))
            ,'require'  => true
        ));
        
        $form->addField('Text', array(
            'name'      => 'org_address_fax'
            ,'value'    => isset($input['cert_org_address_fax'])?$input['cert_org_address_fax']:null
            ,'error'    => (!empty($fieldErorrs['cert_org_address_fax']))
            ,'require'  => true
        ));
        
        $form->addField('Submit', array(
            'name'      => 'action'
            ,'value'    => 'submitCertificate'
            ,'cancel'   => true
        ));
        
        $vars['addForm'] = $form->getHTML();
        
        return array(
            'template'   => 'AddCert'
            ,'vars'      => $vars
        );
    }
    
    function submitCertReissueHTMLAction($input,$vars = array())
    {       
        $certificate                = new CertumSSLCertificate();
        
        $certificate->account       = $this->clientUsername;
        $certificate->userId        = $this->clientUsername;
        
        $certificate->domain        = $input['reissue_domain'];
        $certificate->domainId      = $input['reissue_domain'];
        $certificate->orderToken    = $input['reissue_order_token'];
        $voucherdvMethods           = $certificate->getVoucherDVMethod();
        
        if($voucherdvMethods){
            foreach($voucherdvMethods as $voucherdvMethod){
                if($voucherdvMethod == 'DV'){
                    $certificate->DVMethod = 'DV';
                }
            }
        }

        if(isset($input['reissue_approver_email'])){
            $certificate->approverEmail = $input['reissue_approver_email'];
        }

        $certificate->reissueEmail  = $input['reissue_org_address_email'];

        $certificate->certOrgContacts = array(
            'OrganizationName'      => $input['reissue_org_name']
            ,'company'              => $input['reissue_org_name']
            ,'companypostalcode'    => $input['reissue_org_postalcode']
            ,'country'              => $input['reissue_org_address_country']
            ,'city'                 => $input['reissue_org_address_city']
            ,'state'                => $input['reissue_org_address_region'] 
            ,'email'                => $input['reissue_org_address_email']
            ,'address1'             => $input['reissue_org_address_line1']
            ,'address2'             => $input['reissue_org_address_line2']
            ,'phone'                => $input['reissue_org_address_phone']
            ,'fax'                  => $input['reissue_org_address_fax']
        );
  
        if($errors = $certificate->parseReissueContacts()){
            $vars['fieldErrors'] = $errors;
            return $this->certReissueHTMLAction($input,$vars);
        }else{
            $certificate->generateCSR();     
            $certificate->validateCSR();

            if(!empty($certificate->errors) && array_key_exists('ValidateCSR',$certificate->errors)){
                $errorsArray = $certificate->errors;
                $vars['error'] = $errorsArray['ValidateCSR']['ValidateCSRErrorMessage'];
                return $this->CertReissueHTMLAction($input,$vars);
            }

            $certificate->reissueCertOrder();
            
            if(!empty($certificate->errors) && array_key_exists('Reissue',$certificate->errors)){
                $errorsArray = $certificate->errors;
                $vars['error'] = $errorsArray['Reissue']['ReissueErrorMessage'];
                return $this->certReissueHTMLAction($input,$vars);
            }

            return $this->MainHTMLAction($input,$vars);
        }
    }
    
    
    function submitCertificateHTMLAction($input,$vars = array())
    {
        try{
            $certificate                = new CertumSSLCertificate();
            $certificate->account       = $this->clientUsername;
            $certificate->userId        = $this->clientUsername;
            $certificate->domain        = $input['cert_domain'];
            $certificate->domainId      = $input['cert_domain'];
            $certificate->orderToken    = $input['cert_order_token'];
            $voucherdvMethods           = $certificate->getVoucherDVMethod();
            $certificate->setVoucherProductCode();

            foreach($voucherdvMethods as $voucherdvMethod){
                if($voucherdvMethod == 'DV'){
                    $certificate->DVMethod = 'DV';
                }
            }
            
            if(isset($input['cert_approver_email'])){
                $certificate->approverEmail = $input['cert_approver_email'];
            }
            
            $certificate->certOrgContacts = array(
                'OrganizationName'      => $input['cert_org_name']
                ,'company'              => $input['cert_org_name']
                ,'companypostalcode'    => $input['cert_org_postalcode']
                ,'country'              => $input['cert_org_address_country']
                ,'city'                 => $input['cert_org_address_city']
                ,'state'                => $input['cert_org_address_region']   
                ,'email'                => $input['cert_org_address_email']
                ,'address1'             => $input['cert_org_address_line1']
                ,'address2'             => $input['cert_org_address_line2']
                ,'phone'                => $input['cert_org_address_phone']
                ,'fax'                  => $input['cert_org_address_fax']
            );

            $certificate->certAdminContacts = array(
                'first_name'        => $input['cert_admin_contact_first_name']
                ,'last_name'        => $input['cert_admin_contact_last_name']
                ,'phone'            => $input['cert_admin_contact_phone']
                ,'email'            => $input['cert_admin_contact_email']
                ,'title'            => $input['cert_admin_contact_title']   
                ,'fax'              => $input['cert_admin_contact_fax']
            );

            $certificate->certTechContacts = array(
                'first_name'        => $input['cert_tech_contact_first_name']
                ,'last_name'        => $input['cert_tech_contact_last_name']
                ,'phone'            => $input['cert_tech_contact_phone']  
                ,'email'            => $input['cert_tech_contact_email']
                ,'title'            => $input['cert_tech_contact_title']
                ,'fax'              => $input['cert_tech_contact_fax']
            );
            //echo '<pre>';
            //var_dump($certificate->parseContacts());die;
            if($errors = $certificate->parseContacts()){
                $vars['fieldErrors'] = $errors;
               
                return $this->addCertificateHTMLAction($input,$vars);
            }else{

                $certificate->generateCSR();
                $certificate->validateCSR();

                if(!empty($certificate->errors) && array_key_exists('ValidateCSR',$certificate->errors)){
                    $errorsArray = $certificate->errors;
                    $vars['error'] = $errorsArray['ValidateCSR']['ValidateCSRErrorMessage'];
                    return $this->addCertificateHTMLAction($input,$vars);
                }

                $certificate->placeCertRequest();

                if(!empty($certificate->errors) && array_key_exists('Redeem',$certificate->errors)){
                    $errorsArray = $certificate->errors;
                    $vars['error'] = $errorsArray['Redeem']['ReedemErrorMessage'];
                    return $this->addCertificateHTMLAction($input,$vars);
                }

                $vars['success'] = MGLang::T('orderAddedSuccessfull');
                return $this->MainHTMLAction($input,$vars);
            }
            
        } catch (Exception $ex) {
            //$vars['error'] = 'ERROR: '.$ex->getMessage();
            return $this->MainHTMLAction($input,$vars);
        }
        
    }
    
    function getInfoJSONAction($input,$vars = array())
    {
        if(isset($input['data']["domainName"]) && isset($input['data']["voucherCode"])){
            $certificate                = new CertumSSLCertificate();
            $certificate->account       = $this->clientUsername;
            $certificate->userId        = $this->clientUsername;
            $certificate->domain        = isset($input['data']["domainName"])?$input['data']["domainName"]:null;
            $certificate->domainId      = isset($input['data']["domainName"])?$input['data']["domainName"]:null;
            $certificate->orderToken    = isset($input['data']["voucherCode"])?$input['data']["voucherCode"]:null;
            $vars                       = $certificate->getOrderInformation();
        }

        return $vars;
    }
}