<?php

//ini_set('error_reporting', E_ALL);
//error_reporting(-1);
//ini_set("display_errors", 1);

class DirectadminMainCronController extends DirectadminMasterControllerDriver
{

    public function MainHTMLAction()
    {
        return $this->recentlyCronAction();
    }

    function recentlyCronAction()
    {
        //Parents - Dla nich należy stworzyć wymagane pliki do potwierdzenia i wysłac request
        $parentsCertOrders = new MGCertOrders(array('_tableName' => 'certumssl_orders'));
        $parentsOrder      = $parentsCertOrders->getAllOrders();

        foreach ($parentsOrder as $parentOrder) {
            try {
                $domain         = "";
                $domainRootName = "";
                $notification   = new MGNotification();
                $domainsParams  = CertumSSLDriver::localAPI()->getUserDomains($parentOrder['user_id']);
//            //Sprawdzamy czy urzytkownik posiada jeszcze domene ktora mial przy zamowiowieniu

                foreach ($domainsParams as $domainParam) {
                    if ($domainParam->domain == $parentOrder['domain_id']) {
                        $domain = $parentOrder['domain_id'];
                    }
                }

                if ($domain != "") {
                    $taskParams         = array();
                    $task               = new MGCronTask(array('_tableName' => 'certumssl_cron_tasks'));
                    $task->relid        = "";
                    $task->orderId      = $parentOrder['order_id'];
                    $task->userId       = $parentOrder['user_id'];
                    $task->domainId     = $parentOrder['domain_id'];
                    $task->activateDate = '0000-00-00 00:00:00';
                    $taskParams         = $task->getTaskByOrderId($parentOrder['order_id']);
                    //Tworzy Cron Taska jesli jeszcze nie istnieje
                    if (empty($taskParams)) {
                        $task->create();
                    }

                    $task->updateLastTry();

                    //Pobieramy email klienta
                    $clientName = $parentOrder['user_id'];
                    $userEmail  = CertumSSLDriver::localAPI()->getEmail($clientName);

                    //Pobiera info czy minal jeden dzien od ostatniego wyslanego maila
                    $adminEmailNotifySend = array();
                    $adminEmailNotifySend = $task->passDaysFromLastNotify(1);
                    $notifySended         = false;
                    //Tworzymy plik jesli nie byl jeszcze stworzony
                    if (!$task->fileExist()) {
                        $domainRoot     = CertumSSLDriver::localAPI()->getDomainRoot($parentOrder['user_id'], $domain);
                        $domainRootPath = $domainRoot.'/';

                        // File creation mod
                        $fileToCreate   = 'certum.txt';
                        $fileContent    = $parentOrder['file_content'].'-certum.pl';
                        if ($parentOrder['used_voucher'] == 'zPlG1M0bebQnfDfR') {

                        }

                        if (!file_exists($domainRootPath.".well-known/pki-validation/".$fileToCreate)) {
                            if (!file_exists($domainRootPath.".well-known/pki-validation/")) {
                                mkdir($domainRootPath.".well-known/pki-validation/", 0777, true);
                            }
                            if (!file_put_contents($domainRootPath.".well-known/pki-validation/".$fileToCreate, $fileContent)) {
                                if (!empty($adminEmailNotifySend)) {
                                    $adminNotifyFailureSubject = 'Failed create required file';

                                    $adminFailureNotifyMessage = $this->buildAdminNotifyMessage(
                                        $adminNotifyFailureSubject, $clientName, $userEmail, $domain, $parentOrder['order_id'], $parentOrder['used_token']
                                    );
                                    $notification->adminSummary($adminNotifyFailureSubject, $adminFailureNotifyMessage);
                                    $notifySended              = true;
                                }
                            } else {
                                $task->updateFileExist(1);
                                $parentsCertOrders->updateFileCreated($parentOrder['order_id'], 1);
                                $certificate          = new CertumSSLCertificate();
                                $certificate->userId  = $parentOrder['user_id'];
                                $certificate->orderId = $parentOrder["order_id"];
                                $certificate->verifyDomain($parentOrder['file_name'], $parentOrder['rel_id']);
                            }
                        } else {
                            $certificate          = new CertumSSLCertificate();
                            $certificate->userId  = $parentOrder['user_id'];
                            $certificate->orderId = $parentOrder["order_id"];
                            $certificate->verifyDomain($parentOrder['file_name'], $parentOrder['rel_id']);
                            $parentsCertOrders->updateFileCreated($parentOrder["order_id"], 1);
                            $task->updateFileExist(1);
                        }
                    }
                }
            } catch (\Exception $ex) {

            }
        }

        //chet do listy wszystkich niezainstalowanych certów
        $notInstalledOrders = $parentsCertOrders->getAllNotFinishedOrders();

        foreach ($notInstalledOrders as $key => $OrderToInstall) {
            if (!isset($OrderToInstall['domain_id']) && isset($OrderToInstall['parent_id'])) {
                $OrderToInstall = array_merge($OrderToInstall, $parentsCertOrders->getParentParams($OrderToInstall['parent_id']));
            }
            $notInstalledOrders[$key] = $OrderToInstall;
        }

        //Po wszystkich niezainstalowanych certach
        foreach ($notInstalledOrders as $notInstalledOrder) {

            //Kolejny myk na multidimension
            if (!empty($notInstalledOrder[0])) {
                foreach ($notInstalledOrder[0] as $key => $val) {
                    $notInstalledOrder[$key] = $val;
                }
                unset($notInstalledOrder[0]);
            }


            $domain         = "";
            $domainRootName = "";
            $notification   = new MGNotification();
            $domainsParams  = CertumSSLDriver::localAPI()->getUserDomains($notInstalledOrder['user_id']);
//            //Sprawdzamy czy urzytkownik posiada jeszcze domene ktora mial przy zamowiowieniu
            foreach ($domainsParams as $domainParam) {
                if ($domainParam->domain == $notInstalledOrder['domain_id']) {
                    $domain = $notInstalledOrder['domain_id'];
                }
            }

            if ($domain != "") {

                $taskParams         = array();
                $task               = new MGCronTask(array('_tableName' => 'certumssl_cron_tasks'));
                $task->relid        = "";
                $task->orderId      = $notInstalledOrder['order_id'];
                $task->userId       = $notInstalledOrder['user_id'];
                $task->domainId     = $notInstalledOrder['domain_id'];
                $task->activateDate = '0000-00-00 00:00:00';
                $taskParams         = $task->getTaskByOrderId($notInstalledOrder['order_id']);
                //Tworzy Cron Taska jesli jeszcze nie istnieje
                if (empty($taskParams)) {
                    $task->create();
                }
                $task->updateLastTry();

                $clientAccount      = new CertumSSLAccount($notInstalledOrder['user_id']);
                $orderDetailsParams = array('orderid' => $notInstalledOrder['order_id']);
                $orderDetails       = $clientAccount->orderDetails($orderDetailsParams);

                //Pobieramy email klienta
                $clientName = $notInstalledOrder['user_id'];
                $userEmail  = CertumSSLDriver::localAPI()->getEmail($clientName);

                //Namierzamy konkretne detale dla konkretnego ordera
                foreach ($orderDetails as $orderDetail) {
                    if ($orderDetail["orderdefault"]["orderID"] == $notInstalledOrder['order_id'] && isset($orderDetail['cert']['X509Cert'])) {
                        $installCrt = "Error";
                        $CRT        = "-----BEGIN CERTIFICATE-----\n".$orderDetail['cert']['X509Cert']."\n-----END CERTIFICATE-----";
                        $CRT_CA     = '';

                        if ($CRT != null) {
                            $installCrt = CertumSSLDriver::localAPI()->installCrt($clientName, $domain, $notInstalledOrder['csr_key'], $CRT);
                        }

                        if ($installCrt['error'] !== "0") {
                            $adminEmailNotifySend = array();
                            $adminEmailNotifySend = $task->passDaysFromLastNotify(1);
                            $error                = isset($installCrt['details']) ? $installCrt['details']." ".$installCrt['text'] : $installCrt;

                            if (!empty($adminEmailNotifySend)) {
                                $adminNotifyFailureSubject = 'Failed install certificate';

                                $adminFailureNotifyMessage = $this->buildAdminNotifyMessage(
                                    $adminNotifyFailureSubject, $notInstalledOrder['user_id'], $userEmail, $domain, $notInstalledOrder['order_id'], $notInstalledOrder['used_token'], $error
                                );
                                $notification->adminSummary($adminNotifyFailureSubject, $adminFailureNotifyMessage);
                                $notifySended              = true;
                            }
                        } else {
                            // Ustawia order na Finished/installed
                            if ($notInstalledOrder['order_id'][0] == '_' && $notInstalledOrder['order_id'][strlen($notInstalledOrder['order_id']) - 1] == '_') {
                                $reissueOrders = new MGReissuedOrders(array('_tableName' => 'certumssl_reissued_orders', 'orderId' => $notInstalledOrder['order_id']));
                                $reissueOrders->setFinished(1);
                            } else {
                                $parentOrder = new MGCertOrders(array('_tableName' => 'certumssl_orders', 'orderId' => $notInstalledOrder['order_id']));
                                $parentOrder->setFinished(1);
                            }

                            $adminNotifySubject = MGLang::T('raportTitle');
                            //Success Certfikat został zainstalowany i trzeba wysłać email do klienta
                            try {
                                $notification->userSuccessInstallCertificate($userEmail, array('{$domain}', '{$certificate_id}', '{$voucher_code}'),
                                    array($domain, $notInstalledOrder['order_id'], $notInstalledOrder['used_token']));
                                $adminNotifyMessage = $this->buildAdminNotifyMessage(
                                    $adminNotifySubject, $clientName, $userEmail, $domain, $notInstalledOrder['order_id'], $notInstalledOrder['used_token'], null, 'success'
                                );
                                // Ustawia Cron Task na Finished
                                $notification->adminSummary($adminNotifySubject, $adminNotifyMessage);
                                $task->userId       = $notInstalledOrder['user_id'];
                                $task->domainId     = $notInstalledOrder['domain_id'];
                                $task->activateDate = date('Y-m-d H:i:s');
                                $task->setFinished();
                            } catch (Exception $ex) {
                                MGExceptionLogger::addLog(null, null, $ex);
                            }
                        }
                        if ($notifySended) {
                            $task->updateAdminNotifyDate();
                        }
                    }
                }
            }
        }
    }

    function buildAdminNotifyMessage($title, $clientName, $clientEmail, $clientDomain, $cerumsslOrderId, $voucherCode, $errorMessage = null, $type = 'failure')
    {

        if ($type == 'success') {
            $adminNotifyMessage = "<html>
                <head>
                    <title>".$title."</title>
                </head>
                <body>
                <h4>{$clientName} successfully installed certificate</h4>
                    On Domain: <b>{$clientDomain}</b>, <br>
                    Certum SSL Order ID: <b>{$cerumsslOrderId}</b>,<br>
                    Used Voucher Code: <b>{$voucherCode}</b> ,<br>
                    Client Email: <b>{$clientEmail}
                </body>
            </html>";
        } else {
            $adminNotifyMessage = "<html>
                <head>
                    <title>".$title."</title>
                </head>
                <body>
                <h4>Failed create required file for domain:{$clientDomain}</h4>

                    Details:<br>
                    Client: <b>{$clientName}</b>, <br>
                    Client Email: <b>{$clientEmail}</b>, <br>
                    Certum SSL Order ID: <b>{$cerumsslOrderId}</b>,<br>
                    Used Voucher Code: <b>{$voucherCode}</b> ,<br>";
            if ($errorMessage) {
                $adminNotifyMessage .= "Recived Error Message: ".$errorMessage;
            }
            $adminNotifyMessage .=
                "</body>
            </html>";
        }
        return $adminNotifyMessage;
    }
}