<?php if(!empty($error)): ?>
    <div class="alert alert-danger">
        <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true" >&times;</span><span class="sr-only"><?php echo MGLang::T('close'); ?></span></button>
        <?php echo $error; ?>
    </div>
<?php endif; ?>
<?php if(!empty($success)): ?>
    <div class="alert alert-success">
        <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true" >&times;</span><span class="sr-only"><?php echo MGLang::T('close'); ?></span></button>
        <?php echo $success; ?>
    </div>
<?php endif; ?>

<legend><?php echo MGLang::T('certDetails','currentlyInstalled'); ?></legend>
<table class="table table-hover">
    <thead>
        <tr>
            <th><?php echo MGLang::T('thead','domain'); ?></th>
            <th><?php echo MGLang::T('thead','created'); ?></th>
            <th><?php echo MGLang::T('thead','activated'); ?></th>
            <th><?php echo MGLang::T('thead','status'); ?></th>
            <th><?php echo MGLang::T('thead','actions'); ?></th>
        </tr>
    </thead>
    <tbody>

    <?php if(!empty($certs)): ?>
        <?php foreach($certs as $certVoucher => $cert): ?>
        <tr>
            <td><?php echo $cert['domainId']; ?></td>
           
                <td><?php echo $cert['createdDate']; ?></td>
                <td><?php echo $cert['RedeemDate']; ?></td>
                <td><?php echo $cert['status']; ?></td>
                <td>
                    <button style="margin-bottom:3px;float:left;margin-right: 3px;" type="button" class="btn btn-info btn-xs" data-toggle="modal" data-target="#certDetails" data-action="certInfo" data-domain="<?php echo $cert['domainId']; ?>" data-token="<?php echo $certVoucher; ?>"><?php echo MGLang::T('actions','details'); ?></button>
                    <?php //if($cert['status'] == 'COMPLETE'): ?>
                    <form method="post" style="float: left;margin-right:3px;">
                        <input type="hidden" name="cert_order_token" value="<?php echo $certVoucher; ?>">
                        <input type="hidden" name="cert_domain" value="<?php echo $cert['domainId']; ?>">
                        <button style="margin-bottom:3px;float:left;" type="submit" class="btn btn-info btn-xs" name="action" value="certReissue"><?php echo MGLang::T('actions','reissue'); ?></button>
                    </form>
                    <?php //endif; ?>
                    <?php //if($cert['status'] == 'CANCELLED' && isset($cert['certificate'])): ?>
                        <button style="margin-bottom:3px;float:left;margin-right: 4px;" type="button" class="btn btn-info btn-xs" data-action="certRevoke" data-domain="<?php echo $cert['domainId']; ?>" data-token="<?php echo $certVoucher; ?>"><?php echo MGLang::T('actions','revoke'); ?></button>
                    <?php //endif; ?>
                    <?php //if($cert['status'] != 'CANCELLED'): ?>
                        <button style="margin-bottom:3px;float:left;margin-right: 3px;" type="button" class="btn btn-info btn-xs" data-action="certCancel" data-domain="<?php echo $cert['domainId']; ?>" data-token="<?php echo $certVoucher; ?>"><?php echo MGLang::T('actions','cancel'); ?></button>
                    <?php //endif; ?>
                </td>
        </tr>
        <?php endforeach; ?>
    <?php else: ?>
        <tr>
            <td colspan="5" align="center"> No installed certificate yet </td>
        </tr>
    <?php endif; ?>
    </tbody>
</table>
<?php if(!empty($certs)): ?>
<div class="modal fade" id="certDetails" data-target-on-load="getInfo" tabindex="-1" role="dialog" aria-labelledby="certDetailsLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true" >&times;</span></button>
        <h4 class="modal-title" id="certDetailsLabel"><?php echo MGLang::T('certDetails','title'); ?></h4>
      </div>
      <div class="modal-loader"></div>
      <div class="modal-body">
        <div class="op_info_content" id="order_information">
            <div class="op_info_head">Order Information</div>
            <div class="op_row">
                Voucher code: <span id="op_voucher_code">ABC6255114</span>
            </div>
            <div class="op_row">
               Order ID: <span id="op_order_code">6255114</span>
            </div>
            <div class="op_row">
               Product Type: <span id="op_product_type">Symantec.SecureSite</span>
            </div>
            <div class="op_row">
               Domain Name: <span id="op_domain_name">ertwertwert.com</span>
            </div>
        </div>
        <div class="op_info_content" id="organization_information">
            <div class="op_info_head">Organisation Information</div>
            <div class="op_row op_single_param">
               Name: <span id="op_org_name"></span>
            </div>
            <div class="op_row op_single_param">
               City: <span id="op_org_city"></span>
            </div>
            <div class="op_row op_single_param">
               Fax: <span id="op_org_fax"></span>
            </div>
            <div class="op_row op_single_param">
               Country: <span id="op_org_country"></span>
            </div>
            <div class="op_row op_single_param">
               Region: <span id="op_org_region"></span>
            </div>
            <div class="op_row op_single_param">
               Phone: <span id="op_org_phone"></span>
            </div>
            <div class="op_row op_single_param">
               Address: <span id="op_org_address"></span>
            </div>
            <div class="op_row op_single_param">
               PostalCode: <span id="op_org_postcode"></span>
            </div>
            <div class="op_row op_single_param">
               Email: <span id="op_org_email"></span>
            </div>
        </div>
        <div class="op_info_content" id="technical_information">
            <div class="op_info_head">Technical contact</div>
            <div class="op_row op_single_param">
               Title: <span id="op_tech_title"></span>
            </div>
            <div class="op_row op_single_param">
               First Name: <span id="op_tech_firstname"></span>
            </div>
            <div class="op_row op_single_param">
               Last Name: <span id="op_tech_lastname"></span>
            </div>
            <div class="op_row op_single_param">
               Fax: <span id="op_tech_fax"></span>
            </div>
            <div class="op_row op_single_param">
               Phone: <span id="op_tech_phone"></span>
            </div>
            <div class="op_row op_single_param">
               Email: <span id="op_tech_email"></span>
            </div>
        </div>
        <div class="op_info_content" id="admin_information">
            <div class="op_info_head">Admin contact</div>
            <div class="op_row op_single_param">
               Title: <span id="op_admin_title">Test2</span>
            </div>
            <div class="op_row op_single_param">
               First Name: <span id="op_admin_firstname">Dariusz</span>
            </div>
            <div class="op_row op_single_param">
               Last Name: <span id="op_admin_lastname">Bi</span>
            </div>
            <div class="op_row op_single_param">
               Fax: <span id="op_admin_fax"></span>
            </div>
            <div class="op_row op_single_param">
               Phone: <span id="op_admin_phone"></span>
            </div>
            <div class="op_row op_single_param">
               Email: <span id="op_admin_email"></span>
            </div>
        </div>
        <div class="op_info_content"  id="billing_info">
            <div class="op_info_head">Billing Info:</div>
            <div class="op_row">
               Price: <span id="price">269</span> <span id="currency">EUR</span>
            </div>
        </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal"><?php echo MGLang::T('certDetails','cancel'); ?></button>
      </div>
    </div>
  </div>
</div>
<div class="op_loader">
    <div class="windows8">
            <div class="modal-loader"></div>
    </div>
</div>
<script type="text/javascript">
    
$(document).ready(function(){
    $('body').css('position','relative');
    $('.modal').on('show.bs.modal', function (e) {
        var id = $(e.relatedTarget).attr('data-target-id');
        var action = $(e.currentTarget).attr('data-target-on-load');
        $(e.currentTarget).find('.modal-loader').show();
        $(e.currentTarget).find('.modal-body').hide();
        
        ajaxParser.request(
                action
                ,{
                    id: id
                }
                ,function(result){
                    
                    for(x in result.cert)
                    {
                         $(e.currentTarget).find('textarea[data-text="'+x+'"]').text(result.cert[x]);
                         $(e.currentTarget).find('input[data-value="'+x+'"]').val(result.cert[x]);
                    }
                    
                    $(e.currentTarget).find('.modal-loader').hide();
                    $(e.currentTarget).find('.modal-body').show();
                }
        );
    });
    
    $('.btn').click(function(){
        var certAction = $(this).data('action');

        if(typeof certAction !== "undefined"){
            var domain = $(this).data('domain');
            var voucher = $(this).data('token');
            
            if(certAction != 'certReissue' && certAction != 'certInfo'){
                if(certAction != 'certCancel'){
                    var r = true;
                }else{
                    var txt;
                    var r = confirm("Are you sure you want to cancel this certificate?");
                }
                if (r == true){
                    $(".op_loader").show();
                    $.ajax({
                        type: "POST",
                        url: window.location.href,
                        data: {action:certAction, voucherCode:voucher, domainName:domain},
                        success: function(result){
                            $(".op_loader").hide();
                            $("#MGErrors").remove();
                            var startString = "<<JSON RESPONSE START>>";
                            var stopString = "<<JSON RESPONSE END>>";
                            var start = result.lastIndexOf(startString);   
                            var stop = result.indexOf(stopString);  
                            var jsonResponse = result.substr(start+startString.length,stop);
                            var responseObject = $.parseJSON( jsonResponse.replace('<<JSON RESPONSE END>>', '') );
                            $('.alert.alert-danger').text("");
                            $('.alert.alert-success').show("");
                            if(responseObject.status == "error"){
                                var errorContent = '<div class="row" id="MGErrors">'
                                                        +'<div class="col-lg-12">'
                                                            +'<div class="alertContainer">'
                                                                +'<div class="alertPrototype" style="">'
                                                                    +'<div class="alert alert-danger">'+responseObject.msg+'</div>'
                                                                +'</div>\n'
                                                            +'</div>'
                                                        +'</div>'
                                                    +'</div>';
                                $( "#MGContent" ).prepend( errorContent );
                            }else{
                                var successContent = '<div class="row" id="MGErrors">'
                                                        +'<div class="col-lg-12">'
                                                            +'<div class="alertContainer">'
                                                                +'<div class="alertPrototype" style="">'
                                                                    +'<div class="alert alert-success">'+responseObject.msg+'</div>'
                                                                +'</div>\n'
                                                            +'</div>'
                                                        +'</div>'
                                                    +'</div>';
                                $( "#MGContent" ).prepend( successContent );
                            }

                        }
                    });
                }
            }
        }

        if(certAction == 'certInfo'){
            var domain = $(this).data('domain');
            var voucher = $(this).data('token');
            var action = 'getInfo';
            $("#cpanel_body").css("position","static");
            //$(e.currentTarget).find('.modal-loader').show();
            //$(e.currentTarget).find('.modal-body').hide();
            $("#order_information").hide();
            $(".op_single_param").hide();
            $("#organization_information").hide();
            $("#technical_information").hide();
            $("#admin_information").hide();
            $("#billing_info").hide();
            ajaxParser.request(
                action,
                {domainName: domain,voucherCode: voucher},
                function(result){
                    $.each( result, function( infoHead , infoParams ) {
                        $("#"+infoHead).show();
                        $.each( infoParams, function( inputName , inputValue ) {
                            $('#'+inputName).text(inputValue);
                            $('#'+inputName).parent().show();
                        });
                    });

                    //$(e.currentTarget).find('.modal-loader').hide();
                    //$(e.currentTarget).find('.modal-body').show();
                     $('.modal-backdrop.fade.in').remove();
                }
            );
        }
    });
});
</script>
<?php endif; ?>

<legend><?php echo MGLang::T('certDetails','addNew'); ?></legend>
<?php echo $addForm; ?>