<?php
/**
 * Partner API Library
 * 
 * @copyright Copyright (c) 2013-2014 Unizeto Technologies SA
 * @license license.txt
 */
//var_dump('dsafsadfdaadsfafds');die;
////require_once dirname(__FILE__).'/operation.php';
////require_once ROOTDIR.'/modules/servers/CERTUM_Certificates/certumPartnerAPI/messages/messageGetProductList.php';
////require_once ROOTDIR.'/modules/servers/CERTUM_Certificates/certumPartnerAPI/messages/messageGetProductListResponse.php';

/*
    <operation name="getProductList" parameterOrder="getProductList">
        <input message="tns:PartnerServicePortType_getProductList"/>
        <output message="tns:PartnerServicePortType_getProductListResponse"/>
    </operation>
*/

/**
 * This class represents the operation getProductList.
 * 
 * It is based on the PartnerAPIOperation class and derives some properties and methods from that class.
 * 
 * @method PartnerAPIMessageGetProductListResponse getResponseMessage() A complete response from a service
 * 
 * @package operations
 * @since 1.3.0
 */
class PartnerAPIOperationGetProductList extends PartnerAPIOperation {

    /**
     * @var PartnerAPIMessageGetProductList
     */
    protected $_input = NULL;
    
    /**
     * @var PartnerAPIMessageGetProductListResponse
     */
    protected $_output = NULL;

    /**
     * @var string
     */
    protected $_operation = 'getProductList';
    
    /**
     * The constructor.
     * 
     * It initializes input and output data.
     */
    public function __construct() {
        
        $this->_input  = new PartnerAPIMessageGetProductList();
        $this->_output = new PartnerAPIMessageGetProductListResponse();
    }

    /**
     * Returns products contained in a response.
     * 
     * This method always returns an array.
     * If there is no product in the response an empty array is returned.
     * Otherwise, an array with one or more products is returned.
     * Keys in the array are numbers meaning the product code
     * and values are objects of type PartnerAPITypeProduct.
     * The following properties are set for each product: code, type and
     * validityPeriod.
     * 
     * @return PartnerAPITypeProduct[]
     */
    public function getProducts() {
        $productList = array();
        $products = $this->_output->getProductListResponse->products;
        if (is_null($products))
            return $productList;
        $product = $products->product;
        if (is_array($product))
            foreach ($product as $p)
                $productList[$p->code] = $p;
        else
            $productList[$product->code] = $product;
        return $productList;
    }

}
