<?php
/**
 * Partner API Library
 * 
 * @copyright Copyright (c) 2013-2014 Unizeto Technologies SA
 * @license license.txt
 */

//require_once 'typeRequest.php';
//require_once 'typeAddSerialNumbers.php';
//require_once 'typeRemoveSerialNumbers.php';

/*
<xs:complexType name="modifySNICertificateRequest">
    <xs:complexContent>
        <xs:extension base="tns:request">
            <xs:sequence>
                <xs:element name="serialNumber" type="xs:string"/>
                <xs:element name="X509Cert" type="xs:string"/>
                <xs:element maxOccurs="1" minOccurs="0" name="addSerialNumbers" type="tns:addSerialNumbers"/>
                <xs:element maxOccurs="1" minOccurs="0" name="removeSerialNumbers" type="tns:removeSerialNumbers"/>
            </xs:sequence>
        </xs:extension>
    </xs:complexContent>
</xs:complexType>
*/

/**
 * This class represents the "modifySNICertificateRequest" WSDL type.
 * 
 * It is an extension to the PartnerAPITypeRequest class.
 * 
 * @method PartnerAPITypeModifySNICertificateRequest setSerialNumber(string $value The serialNumber to be set) Sets the "serialNumber" element
 * @method string getSerialNumber() Gets the "serialNumber" element
 * @property string $serialNumber Gets the "serialNumber" element
 * 
 * @method PartnerAPITypeModifySNICertificateRequest setX509Cert(string $value The X509Cert to be set) Sets the "X509Cert" element
 * @method string getX509Cert() Gets the "X509Cert" element
 * @property string $X509Cert Gets the "X509Cert" element
 * 
 * @method PartnerAPITypeModifySNICertificateRequest setAddSerialNumbers(PartnerAPITypeAddSerialNumbers $value The addSerialNumbers to be set or NULL) Sets the "addSerialNumbers" element
 * @method PartnerAPITypeAddSerialNumbers getAddSerialNumbers() Gets the "addSerialNumbers" element or NULL
 * @property PartnerAPITypeAddSerialNumbers $addSerialNumbers Gets the "addSerialNumbers" element or NULL
 * 
 * @method PartnerAPITypeModifySNICertificateRequest setRemoveSerialNumbers(PartnerAPITypeRemoveSerialNumbers $value The removeSerialNumbers to be set or NULL) Sets the "removeSerialNumbers" element
 * @method PartnerAPITypeRemoveSerialNumbers getRemoveSerialNumbers() Gets the "removeSerialNumbers" element or NULL
 * @property PartnerAPITypeRemoveSerialNumbers $removeSerialNumbers Gets the "removeSerialNumbers" element or NULL
 * 
 * @package types
 * @since 1.3.4
 */
class PartnerAPITypeModifySNICertificateRequest extends PartnerAPITypeRequest {
    
    protected function initData() {
        $p = parent::initData();
        $n = array(
            'serialNumber'        => array('min' => 1, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'X509Cert'            => array('min' => 1, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'addSerialNumbers'    => array('min' => 0, 'max' => 1, 'value' => NULL, 'type' => 'PartnerAPITypeAddSerialNumbers', 'nillable' => FALSE),
            'removeSerialNumbers' => array('min' => 0, 'max' => 1, 'value' => NULL, 'type' => 'PartnerAPITypeRemoveSerialNumbers', 'nillable' => FALSE)
        );
        return array_merge($p, $n);
    }

}
