<?php
/**
 * Partner API Library
 * 
 * @copyright Copyright (c) 2013-2014 Unizeto Technologies SA
 * @license license.txt
 */

//require_once 'type.php';
//require_once 'typeValidityPeriod.php';

/*
    <xs:complexType name="orderParameters">
        <xs:sequence>
            <xs:element name="CSR" type="xs:string"/>
            <xs:element name="customer" type="xs:string"/>
            <xs:element minOccurs="0" name="language" type="xs:string"/>
            <xs:element minOccurs="0" name="orderID" type="xs:string"/>
            <xs:element name="productCode" type="xs:string"/>
            <xs:element minOccurs="0" name="userAgent" type="xs:string"/>
            <xs:element minOccurs="0" name="validityPeriod" type="tns:validityPeriod"/>
        </xs:sequence>
    </xs:complexType>
*/

/**
 * This class represents the "orderParameters" WSDL type.
 * 
 * It is based on the PartnerAPIType class and derives some properties and methods from that class.
 * 
 * @method PartnerAPITypeOrderParameters setCSR(string $value The CSR to be set) Sets the "CSR" element
 * @method string getCSR() Gets the "CSR" element
 * @property string $CSR Gets the "CSR" element
 * 
 * @method PartnerAPITypeOrderParameters setCustomer(string $value The customer to be set) Sets the "customer" element
 * @method string getCustomer() Gets the "customer" element
 * @property string $customer Gets the "customer" element
 * 
 * @method PartnerAPITypeOrderParameters setLanguage(string $value The language to be set or NULL) Sets the "language" element
 * @method string getLanguage() Gets the "language" element or NULL
 * @property string $language Gets the "language" element or NULL
 * 
 * @method PartnerAPITypeOrderParameters setOrderID(string $value The orderID to be set or NULL) Sets the "orderID" element
 * @method string getOrderID() Gets the "orderID" element or NULL
 * @property string $orderID Gets the "orderID" element or NULL
 * 
 * @method PartnerAPITypeOrderParameters setProductCode(string $value The productCode to be set) Sets the "productCode" element
 * @method string getProductCode() Gets the "productCode" element
 * @property string $productCode Gets the "productCode" element
 * 
 * @method PartnerAPITypeOrderParameters setUserAgent(string $value The userAgent to be set or NULL) Sets the "userAgent" element
 * @method string getUserAgent() Gets the "userAgent" element or NULL
 * @property string $userAgent Gets the "userAgent" element or NULL
 * 
 * @method PartnerAPITypeOrderParameters setValidityPeriod(PartnerAPITypeValidityPeriod $value The validityPeriod to be set or NULL) Sets the "validityPeriod" element
 * @method PartnerAPITypeValidityPeriod getValidityPeriod() Gets the "validityPeriod" element or NULL
 * @property PartnerAPITypeValidityPeriod $validityPeriod Gets the "validityPeriod" element or NULL
 * 
 * @package types
 * @since 1.3.0
 */
class PartnerAPITypeOrderParameters extends PartnerAPIType {
    
    protected function initData() {
        return array(
            'CSR'            => array('min' => 1, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'customer'       => array('min' => 1, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'language'       => array('min' => 0, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'orderID'        => array('min' => 0, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'productCode'    => array('min' => 1, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'userAgent'      => array('min' => 0, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'validityPeriod' => array('min' => 0, 'max' => 1, 'value' => NULL, 'type' => 'PartnerAPITypeValidityPeriod', 'nillable' => FALSE),
            'email'          => array('min' => 0, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'activationCode' => array('min' => 0, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE)
        );
    }

}
