<?php
/* 
 * * ******************************************************************
 *
 *   CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *   AUTHOR                         ->     dariusz.bi@modulesgarden.com
 *   CONTACT                        ->       contact@modulesgarden.com
 *
 *  This software is furnished under a license and may be used and copied
 *  only  in  accordance  with  the  terms  of such  license and with the
 *  inclusion of the above copyright notice.  This software  or any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and  ownership of the  software is  hereby
 *  transferred.
 *
 * * ******************************************************************
 */

class MGReissuedOrders
{
    private $_tableName;
    private $orderId;
    private $parentId;
    private $createDate;
    private $csr;
    private $private_key;
    
    function __construct(array $params = array())
    {
        $this->load($params);

        if (empty($this->createDate)) {
            $this->createDate = date('Y-m-d H:i:s');
        }
    }

    function load(array $params)
    {
        foreach ($params as $propertyName => $propertyValue) {
            if (property_exists($this, $propertyName)) {
                $this->{$propertyName} = $propertyValue;
            }
        }
    }
    
    function create()
    {
        $toSave = clone $this;
        
        MGMySQL::insert($toSave->_tableName, array(
            'order_id'      => $toSave->orderId,
            'parent_id'     => $toSave->parentId,
            'csr'           => $toSave->csr,
            'private_key'   => $toSave->private_key,
            'date'          => $toSave->createDate
        ));
    }
    
    function setFinished($finished = 0)
    {
        $toSave = clone $this;
        
        MGMySQL::update($toSave->_tableName, array(
            'Finished'    => $finished,
            ), array(
                'order_id' => $toSave->orderId
            )
        );
    }
    
    function getOrderById()
    {
        $toSave = clone $this;
        
        $q = MGMySQL::query("
            SELECT 
                *
            FROM
                `".$toSave->_tableName."`
            WHERE 
                order_id = '".$toSave->orderId."'
            ORDER BY
                id ASC  
        ")->fetchAll();

        $ordersList = array();
        foreach($q as $r)
        {
            $ordersList = array(
                'orderId'       => $r['order_id'],
                'parentId'      => $r['parent_id'],
                'finished'      => $r['Finished']
            );  
        }
        
        return $ordersList;
    }
}
