<?php


/* * ********************************************************************
 * Customization Services by ModulesGarden.com
 * Copyright (c) ModulesGarden, INBS Group Brand, All Rights Reserved 
 * (2013-12-18, 12:25:06)
 * 
 *
 *  CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

/**
 * @author Grzegorz Draganik <grzegorz@modulesgarden.com>
 * @author Piotr Kozdęba <piotr.ko@modulesgarden.com>
 */

/**
 * Gets configuration of DirectAdmin
 * NTODO: gdyby gdzieś nie było dostepu do konfiguracji to należy zrobić taki getconfig jak jest przy module do spamexperts
 */

class DirectAdminConfiguration
{

    protected $filename = 'configuration.conf';
    protected $values;

    public function __construct($filename = null)
    {
        if ($filename)
        {
            $this->filename = $filename;
        }
        
        $this->load();
    }

    protected function load()
    {
        $path = dirname(__FILE__).DS.'..'.DS.'..'.DS.$this->filename;
   
        if (!file_exists($path))
        {
            throw new Exception('Configuration file '.$this->filename.' does not exists', 404);
        }
        
        $output = file_get_contents($path);
        $this->values = parse_ini_string($output);
    }

    public function get($key, $default = null)
    {
        return isset($this->values[$key]) ? stripslashes($this->values[$key]) : $default;
    }

    public function set($key, $value)
    {
        $this->values[$key] = $value;
    }

    public function save()
    {
        $path = dirname(__FILE__) . DS . '..' . DS . $this->filename;
        
        $str = '';
        foreach ($this->values as $k => $v)
        {
            $str .= addslashes($k.'="'.addslashes($v).'"') . "\n";
        }

        file_put_contents($path, $str);
    }
	
}