<?php

class CertumSSLHelper
{

    function __construct()
    {
        ;
    }

    function url_origin($s, $use_forwarded_host = false)
    {
        $ssl      = (!empty($s['HTTPS']) && $s['HTTPS'] == 'on' );
        $sp       = strtolower($s['SERVER_PROTOCOL']);
        $protocol = substr($sp, 0, strpos($sp, '/')).( ( $ssl ) ? 's' : '' );
        $port     = $s['SERVER_PORT'];
        $port     = ( (!$ssl && $port == '80' ) || ( $ssl && $port == '443' ) ) ? '' : ':'.$port;

        $host = ( $use_forwarded_host && isset($s['HTTP_X_FORWARDED_HOST']) ) ? $s['HTTP_X_FORWARDED_HOST'] : ( isset($s['HTTP_HOST']) ? $s['HTTP_HOST'] : null );
        $host = isset($host) ? $host.$port : $s['SERVER_NAME'].$port;
        return $protocol.'://'.$host;
    }

    function full_url($s, $use_forwarded_host = false)
    {
        return $this->url_origin($s, $use_forwarded_host).$s['REQUEST_URI'];
    }

    function certificateInputConditions($input)
    {

        $params = array();
        $params['cert_contactorg_name'] = $input['cert_contactorg_name'];
        if ((isset($input['cert_contact_taxIdentificationNumber']) && $input['cert_contact_taxIdentificationNumber'] != '')) {
            $params['OrganizationName'] = $input['cert_contactorg_name'];
        } else {
            if (isset($input['cert_certdetails_organisation']) && $input['cert_certdetails_organisation'] != '') {
                $params['OrganizationName'] = $input['cert_certdetails_organisation'];
            } elseif (isset($input['cert_contactorg_name']) && $input['cert_contactorg_name'] != '') {
                $params['OrganizationName'] = $input['cert_contactorg_name'];
            } elseif (isset($input['cert_org_name']) && $input['cert_org_name'] != '') {
                $params['OrganizationName'] = $input['cert_org_name'];
            } else {
                $params['OrganizationName'] = $input['cert_contact_firstname'].' '.$input['cert_contact_lastname'];
            }
        }

        if (isset($input['cert_certdetails_country']) && $input['cert_certdetails_country'] != '') {
            $params['country'] = $input['cert_certdetails_country'];
        } elseif (isset($input['org_address_country']) && $input['org_address_country'] != '') {
            $params['country'] = $input['org_address_country'];
        } else {
            $params['country'] = $input['cert_contact_country'];
        }

        if (isset($input['cert_certdetails_locality']) && $input['cert_certdetails_locality'] != '') {
            $params['city'] = $input['cert_certdetails_locality'];
        } elseif (isset($input['org_address_city']) && $input['org_address_city'] != '') {
            $params['city'] = $input['org_address_city'];
        } else {
            $params['city'] = $input['cert_contact_city'];
        }

        if (isset($input['cert_certdetails_state_province']) && $input['cert_certdetails_state_province'] != '') {
            $params['state'] = $input['cert_certdetails_state_province'];
        } elseif (isset($input['cert_org_address_region']) && $input['cert_org_address_region'] != '') {
            $params['state'] = $input['cert_org_address_region'];
        } else {
            $params['state'] = 'Texas';
        }

        if (isset($input['cert_certdetails_email']) && $input['cert_certdetails_email'] != '') {
            $params['email'] = $input['cert_certdetails_email'];
        } elseif (isset($input['org_address_email']) && $input['org_address_email'] != '') {
            $params['email'] = $input['org_address_email'];
        } else {
            $params['email'] = $input['cert_contact_email'];
        }

        if (isset($input['cert_contact_taxIdentificationNumber']) && $input['cert_contact_taxIdentificationNumber'] != '') {
            $params['taxnumber'] = $input['cert_contact_taxIdentificationNumber'];
        } elseif (isset($input['org_taxIdentificationNumber']) && $input['org_taxIdentificationNumber'] != '') {
            $params['taxnumber'] = $input['org_taxIdentificationNumber'];
        } else {
            $params['taxnumber'] = null;
        }

        if(isset($input['cert_org_verifiphonenumber']) && $input['cert_org_verifiphonenumber'] != ''){
            $params['verificationPhoneNumber'] = $input['cert_org_verifiphonenumber'];
        }else{
            $params['verificationPhoneNumber'] = null;
        }

        return $params;
    }
}