<?php

/* * ********************************************************************
 * Customization Services by ModulesGarden.com
 * Copyright (c) ModulesGarden, INBS Group Brand, All Rights Reserved 
 * (2013-12-16, 15:02:23)
 * 
 *
 *  CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

/**
 * @author Grzegorz Draganik <grzegorz@modulesgarden.com>
 */

/**
 * Taki ogólny helper dla pluginów -autolader, pobieranie danych w stylu $params i tworzenie łańcucha paginacji
 */

if (!defined('DS'))
	define('DS', DIRECTORY_SEPARATOR);

//autoloader
function __autoload($class_name) {
	$path = dirname(__FILE__) . DS . $class_name . '.php';
	if (!file_exists($path))
		throw new Exception('File '.$path.' does not exists!');
	include_once $path;
}

//załączanie jquery.js/module.js/style.css i bootstrapa
function pasteAssets(){
	return '
		<script type="text/javascript">'. file_get_contents(dirname(__FILE__).DS.'..'.DS.'assets'.DS.'jquery.js') . '</script>
		<script type="text/javascript">'. file_get_contents(dirname(__FILE__).DS.'..'.DS.'assets'.DS.'module.js') . '</script>
		<style type="text/css">'		. file_get_contents(dirname(__FILE__).DS.'..'.DS.'assets'.DS.'style.css') . '</style>
		<style type="text/css">'		. file_get_contents(dirname(__FILE__).DS.'..'.DS.'assets'.DS.'bootstrap.min.css') . '</style>
	';
}

//pobieranie parametru requesta (nie ważne czy GET czy POST czyjeszcze coś innego)
function getParam($key, $default = null){
	$params = getParams();
	return isset($params[$key]) ? $params[$key] : $default;
}

function getParams(){
	parse_str($_SERVER['QUERY_STRING'], $output);
	return $output;
}


//zwraca html z paginacją dla zadanych parametrów
function pastePaginationHtml($total, $page, $limit, array $additionalParams = array()){
	$pagesStr = '';
	$urlStr = '?';
	foreach ($additionalParams as $k => $v)
		$urlStr .= $k . '=' . $v . '&';
	$pagesCount = ceil($total / $limit);
	for ($p = 1; $p <= $pagesCount; $p++){
		$pagesStr .= '<a href="'.$urlStr.'page='.$p.'" class="paginationItem '.($page == $p ? 'current' : '').'">'.$p.'</a> ';
	}
	return '
		<div class="paginationContainer">
			<div class="paginationLeft">
				Page '.$page.' of '.($pagesCount == 0 ? 1 : $pagesCount).'; Total '.$total.'
			</div>
			<div class="paginationRight">
				'.($pagesStr ? 'Page: '.$pagesStr : '').'
			</div>
			<div style="clear:both;">
		</div>
	';
}
